package
{
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.events.TimerEvent;
    import flash.text.TextField;
    import flash.text.TextFieldAutoSize;
    import flash.text.TextFormat;
    import flash.utils.Timer;

    public class TimeWidget extends Sprite {
        
        public static const TICK:String = "tick";
        
        private var timer:Timer = new Timer(1000, 0);
        private var display:TextField = new TextField();
        
        public function TimeWidget() {
            super();
            timer.addEventListener(TimerEvent.TIMER, onTimer);
            
            var format:TextFormat = new TextFormat();
            format.font = "Verdana";
            format.color = 0x6F6F6F;
            format.size = 40;
            
            display.autoSize = TextFieldAutoSize.CENTER;
            display.defaultTextFormat = format;
            display.text = "00:00";
            
            addChild(display);
        }
        
        public function start():void {
            timer.start();
        }
        
        public function stop():void {
            timer.stop();
        }
        
        public function reset():void {
            display.text = "00:00";
        }
        
        private function onTimer(event:TimerEvent):void {
            var timeParts:Array = display.text.split(":");
            var minutes:int = parseInt(timeParts[0]);
            var seconds:int = parseInt(timeParts[1]);
            
            seconds += 1;
            if (seconds >= 60) {
                seconds = 0;
                minutes += 1;
            }
            
            var show:String = "";
            
            if (minutes < 10) {
                show = "0";
            }
            show += minutes.toString() +":";
            if (seconds < 10) {
                show += "0";
            }
            show += seconds.toString();
            
            display.text = show;
            
            var tickEvent:Event = new Event(TimeWidget.TICK);
            dispatchEvent(tickEvent);
        }
        
        /**
        * Number of seconds elapsed since started.
        */
        public function get seconds():int {
            var timeParts:Array = display.text.split(":");
            var minutes:int = parseInt(timeParts[0]);
            var seconds:int = parseInt(timeParts[1]);
            
            return minutes * 60 + seconds;            
        }
    }
}